import os.path
import kinterbasdb as k

DB_NAME = 'D:/temp/test2.db'
PASSWORD = 'masterkey'

if os.path.exists(DB_NAME):
    k.connect(dsn=DB_NAME, user='sysdba', password=PASSWORD).drop_database()

con = k.create_database("create database '%s' user 'sysdba' password '%s'"
    % (DB_NAME, PASSWORD)
  )
con.close()

con = k.connect(dsn=DB_NAME, user='sysdba', password=PASSWORD, charset='ISO8859_1')

cur = con.cursor()

cur.execute("""
    create table test (
      a varchar(50) character set unicode_fss,
      b varchar(50) character set iso8859_1
    )
  """)
con.commit()

charsetCodesEncountered = []
def unicode_conv_in((unicodeString, dbCharacterSetCode)):
    # dbCharacterSetCode is the value of the underlying XSQLVAR.sqlsubtype.
    charsetCodesEncountered.append(dbCharacterSetCode)
    return 'X' # Actual field values are not important to this test; return a dummy.

con.set_type_trans_in({'TEXT_UNICODE': unicode_conv_in})

inValUTF8 = u'\u2211' # N-Ary Summation symbol
inValLatin1 = u'\xff' # Latin Small Letter Y With Diaresis

cur.execute("insert into test values (?,?)", (inValUTF8, inValLatin1))

# The converter should've been asked to convert values with character set codes
# 3 (UNICODE_FSS) and 21 (ISO8859_1).  These codes are loaded by the DB engine
# into XSQLVAR.sqlsubtype, of course.
assert charsetCodesEncountered == [3, 21]
